<?php

namespace CustomerManagement\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateDeviceNameInput StructType
 * @subpackage Structs
 */
class UpdateDeviceNameInput extends AbstractStructBase
{
    /**
     * The CustomerId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $CustomerId;
    /**
     * The DeviceId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $DeviceId;
    /**
     * The NewDeviceName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $NewDeviceName;
    /**
     * Constructor method for UpdateDeviceNameInput
     * @uses UpdateDeviceNameInput::setCustomerId()
     * @uses UpdateDeviceNameInput::setDeviceId()
     * @uses UpdateDeviceNameInput::setNewDeviceName()
     * @param int $customerId
     * @param int $deviceId
     * @param string $newDeviceName
     */
    public function __construct($customerId = null, $deviceId = null, $newDeviceName = null)
    {
        $this
            ->setCustomerId($customerId)
            ->setDeviceId($deviceId)
            ->setNewDeviceName($newDeviceName);
    }
    /**
     * Get CustomerId value
     * @return int
     */
    public function getCustomerId()
    {
        return $this->CustomerId;
    }
    /**
     * Set CustomerId value
     * @param int $customerId
     * @return \CustomerManagement\StructType\UpdateDeviceNameInput
     */
    public function setCustomerId($customerId = null)
    {
        // validation for constraint: int
        if (!is_null($customerId) && !(is_int($customerId) || ctype_digit($customerId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($customerId, true), gettype($customerId)), __LINE__);
        }
        $this->CustomerId = $customerId;
        return $this;
    }
    /**
     * Get DeviceId value
     * @return int
     */
    public function getDeviceId()
    {
        return $this->DeviceId;
    }
    /**
     * Set DeviceId value
     * @param int $deviceId
     * @return \CustomerManagement\StructType\UpdateDeviceNameInput
     */
    public function setDeviceId($deviceId = null)
    {
        // validation for constraint: int
        if (!is_null($deviceId) && !(is_int($deviceId) || ctype_digit($deviceId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($deviceId, true), gettype($deviceId)), __LINE__);
        }
        $this->DeviceId = $deviceId;
        return $this;
    }
    /**
     * Get NewDeviceName value
     * @return string|null
     */
    public function getNewDeviceName()
    {
        return $this->NewDeviceName;
    }
    /**
     * Set NewDeviceName value
     * @param string $newDeviceName
     * @return \CustomerManagement\StructType\UpdateDeviceNameInput
     */
    public function setNewDeviceName($newDeviceName = null)
    {
        // validation for constraint: string
        if (!is_null($newDeviceName) && !is_string($newDeviceName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($newDeviceName, true), gettype($newDeviceName)), __LINE__);
        }
        $this->NewDeviceName = $newDeviceName;
        return $this;
    }
}
